unit Hexcolor;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, JPEG, GIFImage;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    rgp1: TRadioGroup;
    sbr: TScrollBar;
    sbg: TScrollBar;
    sbb: TScrollBar;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    BitBtn1: TBitBtn;
    Label6: TLabel;
    ColorDialog1: TColorDialog;
    edText: TEdit;
    edBkground: TEdit;
    bbtnColor: TBitBtn;
    bbtnSel: TBitBtn;
    edSetColor: TEdit;
    OpenDialog1: TOpenDialog;
    Image1: TImage;
    lbText: TLabel;
    ckBoxStretched: TCheckBox;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    procedure BitBtn1Click(Sender: TObject);
    procedure sbrChange(Sender: TObject);
    procedure sbgChange(Sender: TObject);
    procedure sbbChange(Sender: TObject);
    procedure rgp1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bbtnColorClick(Sender: TObject);
    procedure bbtnSelClick(Sender: TObject);
    procedure ckBoxStretchedClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
end;

const
      HexaTable='0123456789ABCDEF';
var
  Form1: TForm1;
  R,G,B : word;
  oldcolor : longint;
  rgbstr,nostr: string;
  txtTop, txtLeft : integer;
implementation

{$R *.DFM}
uses MoveText0;

function getValue(ch : char):word;
var
    k : integer;
begin
  for k:=1 to 16 do
     begin
       if ( ch=HexaTable[k] ) then
         begin
           result:=k-1;
           exit;
         end;
     end;
end;

function HexStrToValue(s : string):LongInt;
const Pick : array[1..6] of BYTE
           = (2,1,4,3,6,5);      // for the #RRGGBB color type
var
   len , k, value : integer;
begin
  len:=Length(s);
  if ( len<>6 ) or ( s[1]='#' ) then
    begin
      ShowMessage('пJ6 16i!!'+#13+'B}Yݭn''#''Ÿ');
      exit;
    end;
  s:=UpperCase(s);
  result:=0;
  for k:=6 downto 1 do
     begin
       result:=(result shl 4) + getValue(s[pick[k]]);
     end;
end;

procedure Tostr(k : integer);
begin
  if k<10 then nostr:=inttostr(k)
  else nostr:=chr(k+55);
end;

procedure Hex(n : integer);  // can be done by 'IntToHex(value, digit)'
begin
  if ( n < 16 ) then
     begin
       Tostr(n);
       rgbstr:=rgbstr+nostr;
     end
  else begin
         Hex( n div 16);
         Tostr(n mod 16);
         rgbstr:=rgbstr+nostr;
       end;
end;

procedure HexaColor;
begin
  r:=form1.sbr.position;
  g:=form1.sbg.position;
  b:=form1.sbb.position;
  rgbstr:='#';
  if r<16 then rgbstr:=rgbstr+'0';
  Hex(r);
  if g<16 then rgbstr:=rgbstr+'0';
  Hex(g);
  if b<16 then rgbstr:=rgbstr+'0';
  Hex(b);
  if form1.rgp1.itemindex=0 then
     begin
       form1.edText.Text:=rgbstr;
       form1.panel1.font.color:=rgb(R,G,B);
     end
  else if form1.rgp1.itemindex=1 then
         begin
           form1.edBkGround.Text:=rgbstr;
           form1.panel1.color:=rgb(R,G,B);
         end
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.sbrChange(Sender: TObject);
begin
  HexaColor;
end;

procedure TForm1.sbgChange(Sender: TObject);
begin
  HexaColor;
end;

procedure TForm1.sbbChange(Sender: TObject);
begin
  HexaColor;
end;

procedure TForm1.rgp1Click(Sender: TObject);
begin
  if ( rgp1.ItemIndex=2 ) then  // background picture selected
    begin
      Image1.Visible:=true;
      if ( OpenDialog1.Execute ) then
        begin
          Image1.Picture.LoadFromFile(OpenDialog1.FileName);
          Image1.Visible:=true;
        end;
      rgp1.ItemIndex:=0; // to advoid selection staying same position
      exit;
    end;
  if ( rgp1.itemindex=0 ) then
    begin
      oldcolor:=ColorToRGB(panel1.font.color)
    end
  else
    begin
      oldcolor:=ColorToRGB(panel1.color);
      Image1.Visible:=false;
    end;
  sbr.position:=GetRValue(oldcolor);
  sbg.position:=GetGValue(oldcolor);
  sbb.position:=GetBValue(oldcolor);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  rgp1.itemindex:=1;
  rgp1.itemindex:=0;
  bbtnSel.Font.Color:=RGB($FF,$00,$80);
  txtTop:=lbText.Top;
  txtLeft:=lbText.Left;
  panel1.Caption:='';
end;

procedure TForm1.bbtnColorClick(Sender: TObject);
var
   r,g,b : BYTE;
   color : longInt;
begin
  if ColorDialog1.Execute then
    begin
      color := ColorDialog1.Color;
      sbr.position:=GetRValue(color);
      sbg.position:=GetGValue(color);
      sbb.position:=GetBValue(color);
    end;
end;

procedure TForm1.bbtnSelClick(Sender: TObject);
var
   color : LongInt;
begin
  color := HexStrToValue(edSetColor.Text);
  sbr.position:=GetRValue(color);
  sbg.position:=GetGValue(color);
  sbb.position:=GetBValue(color);
  edSetColor.Text:=UpperCase(edSetColor.Text);
end;

procedure TForm1.ckBoxStretchedClick(Sender: TObject);
begin
  Image1.Stretch := ckBoxStretched.Checked;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if ( Key=VK_UP ) then
    lbText.Top:= lbText.Top-1
  else if ( Key=VK_DOWN ) then
    lbText.Top:= lbText.Top+1;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
  lbText.Top  := txtTop;
  lbText.Left := txtLeft;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  Form2.ShowModal;
end;

end.
